<script lang="ts">
  import domino2025 from "$lib/assets/images/2025-dominos.svg";
  import { hasApiRole } from "$lib/components/layout/data/nav-tabs.js";
  import { authTokenParsed } from "$stores/authStore.js";
  import User from "$lib/components/ui-elements/User.svelte";
  import { Button } from "flowbite-svelte";
  import html2canvas from "html2canvas";
  import type { TeamScorecard$result } from "$houdini";

  type ServiceSnapshot = TeamScorecard$result["events"][0]["teams"][0]["team"]["snapshots"][0]["services"][0]

  export let team: TeamScorecard$result["events"][0]["teams"][0]["team"];
  export let event: TeamScorecard$result["events"][0];
  export let role: string | undefined;
  let clazz = "";
  export { clazz as class };

  let scorecardEle: HTMLElement;

  async function getMostValuableService(services: ServiceSnapshot[]): Promise<ServiceSnapshot> {
    return services.sort((a: ServiceSnapshot, b: ServiceSnapshot) => b.score - a.score)[0];
  }

  function getTotalBonusScore(bonus_scores: Array<{ score: number }>): number {
    return bonus_scores.reduce((acc: number, s: { score: number }) => acc + s.score, 0);
  }

  async function saveScorecard() {
    // todo support saving image with html2canvas
    // currently there is a bug that doesn't include the remote SVG badge images
    let canvas = await html2canvas(scorecardEle, { useCORS: true });
    let image = canvas.toDataURL("image/png").replace("image/png", "image/octet-stream");

    let downloadLink = document.createElement("a");
    downloadLink.href = image;
    downloadLink.download = "scorecard.png"; // Set the filename here

    // Append the link to the document body temporarily
    document.body.appendChild(downloadLink);
    downloadLink.click();
    document.body.removeChild(downloadLink);
  }

</script>

<section class:clazz>
  <!-- this loop just gets access to the current team; there will only be 1 -->
  <div bind:this={scorecardEle} class="grid grid-cols-6 xl:grid-cols-12 border-cyber-blue-900 border-8 xl:border-r-0">
    <!-- Left Scorecard -->
    <div class="col-span-full xl:col-span-4 flex flex-col justify-center items-center">
      <div class="text-2xl text-center py-12">{event.name}</div>
      <div class="text-2xl text-center pb-12">
        {team.long_name}
      </div>
      {#if (!!team.institution) && !team.long_name?.toLowerCase().includes(team.institution.name.toLowerCase())}
        <div class="text-2xl text-center pb-12">{team.institution.name}</div>
      {/if}
      <img class="block py-5 px-6" src={domino2025}>
      <b class="py-12 text-4xl font-poppins">How'd you do?</b>
    </div>

    <!-- Right Scorecard -->
    <div
      class="col-span-8 md:px-5 pb-5 grid grid-cols-2 sm:grid-cols-3 bg-cyber-blue-900 text-white font-poppins font-light text-center">
      <!-- By the numbers header -->
      <div class="col-span-full grid grid-cols-4 items-center justify-center by-the-numbers pb-10 md:-mr-5">
        <!-- pre-year red line -->
        <div class="border-t border-red-800"></div>
        <span class="text-lg fond-bold px-2 whitespace-nowrap">THE 2025</span>
        <!-- post-year red line -->
        <div class="flex-grow border-t border-red-800 mr-2"></div>
        <div class="col-start-1 col-span-3 text-3xl md:text-4xl lg:text-5xl text-left">NCAE <b class="font-black">CYBER
          GAMES</b></div>
        <!-- desktop BY THE NUMBERS-->
        <div class="max-sm:hidden col-start-4 pl-2 py-4 my-4 row-span-2 row-start-1 bg-red-800 whitespace-nowrap">
                  <span
                    class="text-sm text-light ml-2 my-auto p-1 pr-6 border-y-2 border-l-2 border-gray-800 font-mono">BY THE NUMBERS</span>
        </div>
        <!-- mobile BY THE NUMBERS-->
        <div class="sm:hidden col-start-1 col-span-full py-2 bg-red-800 whitespace-nowrap">
          <div
            class="text-sm text-light ml-2 my-auto p-1 pr-6  border-gray-800 font-mono">BY THE NUMBERS
          </div>
        </div>
      </div>

      <!-- Points Row -->
      <div class="sm:col-start-1 sm:row-start-2">
        <div class="text-2xl">
          SERVICE POINTS
        </div>
        <div class="col-span-2 text-3xl py-1 font-extrabold">
          {Math.floor(team.snapshots[0].services_score)}
        </div>
      </div>

      <div class="max-sm:col-span-full max-sm:row-start-2">
        <div class="text-4xl">FINAL SCORE</div>
        <div class="text-5xl py-1 font-extrabold">
          {Math.floor(team.snapshots[0].total_score)}
        </div>
      </div>

      <div>
        <div class="text-2xl">CTF POINTS</div>
        <div class="text-3xl py-1 font-extrabold">
          {Math.floor(team.snapshots[0].ctf_score)}
        </div>
      </div>

      <!-- service / bonus / flags row -->
      <div>
        <div class="text-2xl pt-6">TOP SERVICE</div>
        {#await getMostValuableService(team.snapshots[0].services) then service}
          <div class="text-3xl py-1 font-extrabold">
            {service.check.display_name}
          </div>
          <div>{Math.floor(service.accrued_checks / service.max_checks * 100)}% Uptime</div>
        {/await}
      </div>

      <div class="max-sm:col-span-full max-sm:row-start-3">
        {#if getTotalBonusScore(team.snapshots[0].bonus_scores) > 0}
          <div class="text-2xl pt-6">BONUS POINTS</div>
          <div class="text-3xl py-1 font-extrabold">
            {getTotalBonusScore(team.snapshots[0].bonus_scores)}
          </div>
        {/if}
      </div>

      <div>
        <div class="text-2xl pt-6">FLAGS CAPTURED</div>
        <div class="text-3xl py-1 font-extrabold">
          {team.snapshots[0].ctf_challenge_count} / {team.snapshots[0].ctf_challenge_available}
        </div>
      </div>

      <!-- MIT/MVT Awards -->
      <div class="col-span-full col-start-1 flex flex-row pt-20">
        {#each team.awards as award}
          <div class="flex flex-col flex-grow">
            <h3 class="text-center text-2xl text-extrabold pb-4">{award.badge.name}</h3>
            <img style="max-width: 75%; stroke: #FFF; stroke-width: 20px" class="mx-auto"
                 src="{award.badge.img_dark}">
            <span class="mx-auto pt-4 text-2xl">
                      <User hideDiscord hideEmail hideStats user="{award}"></User>
                     </span>
          </div>
        {/each}
      </div>
    </div>
  </div>
  {#if hasApiRole($authTokenParsed, 'staff') }
    <!-- beta feature, show staff only for now -->
    <Button color="green" class="py-2 mt-2 float-right" on:click={saveScorecard}>Save Scorecard</Button>
  {/if}
</section>

<style>
  .by-the-numbers {
      grid-template-columns: minmax(10px, 50px) 1fr minmax(100px, 999999px) 1fr;
  }
</style>
